import { useContext } from 'react';
import { DndContext } from '../../common/DndContext';
// @ts-ignore
import invariant from 'invariant';
/**
 * A hook to retrieve the DragDropManager from Context
 */
export function useDragDropManager() {
    const { dragDropManager } = useContext(DndContext);
    invariant(dragDropManager != null, 'Expected drag drop context');
    return dragDropManager;
}
